//
// Copyright 2002,2003 Sony Corporation 
//
// Permission to use, copy, modify, and redistribute this software for
// non-commercial use is hereby granted.
//
// This software is provided "as is" without warranty of any kind,
// either expressed or implied, including but not limited to the
// implied warranties of fitness for a particular purpose.
//

#ifndef NetworkUdp_h_DEFINED
#define NetworkUdp_h_DEFINED

#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include "UDPConnection.h"
#include "NetworkUdpConfig.h"
#include "VisionInfo.h"
#include "ControlInfo.h"
#include "def.h"

class NetworkUdp : public OObject {
public:
    NetworkUdp();
    virtual ~NetworkUdp() {}

    OSubject*   subject[numOfSubject];
    OObserver*  observer[numOfObserver];     

    virtual OStatus DoInit   (const OSystemEvent& event);
    virtual OStatus DoStart  (const OSystemEvent& event);
    virtual OStatus DoStop   (const OSystemEvent& event);
    virtual OStatus DoDestroy(const OSystemEvent& event);

    void SendCont   (ANTENVMSG msg);
    void ReceiveCont(ANTENVMSG msg);
    void CloseCont  (ANTENVMSG msg);
    void NotifyObjInfo( const ONotifyEvent& event );
    void NotifySTNInfo( const ONotifyEvent& event );

private:
    OStatus Bind   (int index);
    OStatus Send   (int index);
    OStatus Receive(int index);
    OStatus Close  (int index);
    OStatus InitUDPBuffer(int index);
    OStatus CreateUDPEndpoint(int index);

    antStackRef    ipstackRef;
    UDPConnection  connection[NETWORKUDP_CONNECTION_MAX];
    CdtInfo        cdtInfo;
    STNInfo	   stnInfo;
};

#endif // NetworkUdp_h_DEFINED
